note
	description: "The Boss will sporadically issue work to the secretary, but it will allow the secretary to be interrupted by customers."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	BOSS

create
	make

feature

	make (sr: separate SECRETARY_RECEPTIONIST)
		do
			secretary_receptionist := sr
			placed := 0

			set_holder_behaviour_yield
		end

	live
		do
			from

			until
				placed >= 100000
			loop
				issue_work (secretary_receptionist)
			end
		rescue
			print ("In rescue clause of BOSS.live.%N")
		end

	issue_work (sr: separate SECRETARY_RECEPTIONIST)
		--Will work with the secretary forever, or until interrupted
		local
			b, interrupted: BOOLEAN
		do
			if interrupted then
				print ("BOSS has been interrupted, will try to regain lock.%N")
			else
				from

				until
					placed >= 100000
				loop
					b := sr.do_work
					placed := placed + 1
					if (placed // 1000) * 1000 = placed then
						print ("BOSS placed work #" + placed.out + ".%N")
					end
				end
			end
		rescue
			print ("In rescue clause of BOSS.issue_work.%N")
			interrupted := True
			retry
		end

	secretary_receptionist: separate SECRETARY_RECEPTIONIST
	placed: INTEGER
end
