note
	description: "The customer will try to interrupt the receptionist in order to get some quick info."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CUSTOMER

create
	make

feature

	make (sr: separate SECRETARY_RECEPTIONIST)
		do
			secretary_receptionist := sr
			placed := 0

			set_challenger_behaviour_insist
		end

	live
		do
			from

			until
				placed >= 100
			loop
				interrupt (secretary_receptionist)
				wait
			end
		rescue
			print ("In rescue clause of CUSTOMER.live.%N")
		end

	interrupt (sr: separate SECRETARY_RECEPTIONIST)
		--Just a quick query
		local
			b: BOOLEAN
		do
			b := sr.do_work
			placed := placed+1
			print ("CUSTOMER placed work #" + placed.out + ".%N")
		rescue
			print ("In rescue clause of CUSTOMER.interrupt.%N")
		end

	wait
		local
			i: INTEGER
		do
			from
				i := 1
			until
				i > 1000 * slowdown
			loop
				i := i+1
			end
		end

	slowdown: INTEGER = 100

	secretary_receptionist: separate SECRETARY_RECEPTIONIST
	placed: INTEGER
end
