note
	description: "Summary description for {CHALLENGER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CHALLENGER

create
	make

feature

	make (w: separate WORKER; i: INTEGER)
		local
			b: BOOLEAN
		do
			set_challenger_behaviour_wait_turn

			worker := w
			max := i
		end

	live
		do
			do_work (worker)
		rescue
			print ("CHALLENGER.live (rescue)%N")
		end

	do_work (w: separate WORKER)
		local
			b: BOOLEAN
			i: INTEGER
		do
			print ("CHALLENGER starting work.%N")
			from
				i := 1
			until
				i > max
			loop
				b := w.short_work (i, max)
				i := i + 1
			end
			print ("CHALLENGER finished work.%N")
		rescue
			print ("CHALLENGER.do_work (rescue)%N")
		end

	worker: separate WORKER
	max: INTEGER
end
