note
	description: "Summary description for {WORKER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WORKER

create
	make

feature
	make
		do

		end

	send_async_call (o: separate WORKER): BOOLEAN
		do
			o.receive_async_call
			Result := True
		end

	send_async_call_fail (o: separate WORKER): BOOLEAN
		do
			o.receive_async_call_fail
			Result := True
		end

	send_sync_call (o: separate WORKER): BOOLEAN
		do
			Result := o.receive_sync_call
		end

	send_sync_call_fail (o: separate WORKER): BOOLEAN
		do
			Result := o.receive_sync_call_fail
		end

	send_self_call: BOOLEAN
		do
			Result := Current.receive_sync_call
--			Result := True
		end

	send_self_call_fail: BOOLEAN
		do
			Result := Current.receive_sync_call_fail
--			my_exception.raise
--			Result := True
		rescue
--			print ("In Rescue of WORKER.send_self_call_fail.%N")
			writeln (524)
		end

	receive_async_call
		do
			--Do Nothing
		rescue
--			print ("In Rescue of WORKER.receive_async_call.%N")
			writeln (525)
		end

	receive_async_call_fail
		do
			my_exception.raise
		rescue
--			print ("In Rescue of WORKER.receive_async_call_fail.%N")
			writeln (526)
		end

	receive_sync_call: BOOLEAN
		do
			Result := True
		rescue
--			print ("In Rescue of WORKER.receive_sync_call.%N")
			writeln (527)
		end

	receive_sync_call_fail: BOOLEAN
		do
			my_exception.raise
			Result := True
		rescue
--			print ("In Rescue of WORKER.receive_sync_call_fail.%N")
			writeln (528)
		end

	my_exception: DEVELOPER_EXCEPTION
            once
                create Result
            end
	writeln (s: INTEGER)
		external
			"C inline"
		alias
			"writeln($s);"
		end

	writelnTwoArgs (s, x: INTEGER)
		external
			"C inline"
		alias
			"writelnTwoArgs($s, $x);"
		end
end
