--FAIL: The system of swallowing exceptions when locks are released means that the entire approach as such is unfeasible.
--SOLUTION: Implement an ANSWER_REGISTER, which is fed through the DFR. Workers feed/nudge the DFR, but then query the AR.
--			AR then manually generates exceptions when necessary, leaving the burden of exceptions with the developer.


note
	description : "readfile_improved_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w: separate WORKER
			dfr: separate DEDICATED_FILE_READER
			ans: separate ANSWER_REGISTER
			i: INTEGER
		do
			create ans.make
			create dfr.make (ans)

			--print ("Now creating WORKERs.%N")

			from
				i := 1
			until
				i > 2
			loop
				create w.make (i, dfr, ans)
				start (w)
				i := i+1
			end
		end

	start (w: separate WORKER)
		do
			w.live
		end

end
