--This should work, as long as the Workers produce into the BB synchronously!


note
	description : "readfile_improved_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w: separate WORKER
			bb: separate BOUNDED_BUFFER[INTEGER]
			dfr: separate DEDICATED_FILE_READER
			ans: separate ANSWER_REGISTER
			i: INTEGER
		do
			create ans.make
			create bb.make_with_capacity(10)
			create dfr.make (ans, bb)
			start (dfr)

			from
				i := 1
			until
				i > 2
			loop
				create w.make (i, bb, ans)
				insert_and_start (w)
				i := i+1
			end
		end

	start (dfr: separate DEDICATED_FILE_READER)
		do
			dfr.live
		end

	insert_and_start (w: separate WORKER)
		do
			w.live
		end

end
