note
	description: "Summary description for {WORKER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WORKER

create
	make

feature

	make (i: INTEGER; b: separate BOUNDED_BUFFER[INTEGER]; a: separate ANSWER_REGISTER)
		do
			number := i
			ans := a
			bb := b
		end

	live
		do
			from

			until
				counter > 100
			loop
				if not waiting then
					queue_file (bb)
				end
				get_results (ans)
			end
		rescue
			retry	--Ah, the good old on error continue ;)
		end

	queue_file (b: separate BOUNDED_BUFFER[INTEGER])
		local
			boo: BOOLEAN
		do
			b.put (number * 1000000 + counter)
			boo := b.is_full			--Synchronous call needed!
		rescue
			--print ("WORKER " + number.out + ": Could not produce into Bounded Buffer.%N")
		end

	get_results (a: separate ANSWER_REGISTER)
		local
			res: STRING
		do
			create res.make_from_separate (a.get_results ((number * 1000000 + counter).out))
			if res.count > 0 then
				waiting := False
				counter := counter + 1
				--print ("WORKER " + number.out + ": Result: " + res + "%N")
			else
				waiting := True
				--print ("WORKER " + number.out + ": Result: None, waiting.%N")
			end
		rescue
			print ("WORKER " + number.out + ": Encountered exception. Seems like file was not readable ;(%N")
			waiting := False
			counter := counter + 1
		end

feature {NONE}

	number: INTEGER
	ans: separate ANSWER_REGISTER
	bb: separate BOUNDED_BUFFER[INTEGER]
	waiting: BOOLEAN
	counter: INTEGER

end
