note
	description: "Summary description for {ANSWER_REGISTER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ANSWER_REGISTER

create
	make

feature

	make
		do
			create output.make (5)
		end

	put_answer (line, file_name: separate STRING)
		local
			l, f: STRING
		do
			--print ("AR: Receving Answer.%N")
			create l.make_from_separate (line)
			create f.make_from_separate (file_name)
			output.put (l, f)
		rescue
			--print ("AR: Uh oh... put_answer%N")
		end


	get_results (file_name: separate STRING): STRING
		local
			s: STRING
			res: STRING
		do
			create s.make_from_separate (file_name)
			--print ("AR: Trying to get results for File " + s + "...%N")

			res := output.item (s)

			if res /= Void and then not res.is_equal ("ERROR") then
				Result := output.found_item	--Return output
				--print ("AR: Done.%N")
			elseif res /= Void then
				--print ("AR: Error! File not readable...%N")
				--my_exception.raise			--Error encountered...
				Result := "ERROR"				--Old system, so we can't raise an exception!
			else
				--print ("AR: Error! File not (yet) available...%N")
				Result := ""
			end
		rescue
			--print ("AR: Uh oh... get_results. This deadlocks the system.%N")
		end

feature {NONE}

output: HASH_TABLE[STRING, HASHABLE]

end
