note
	description: "Summary description for {AGGREGATOR}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	AGGREGATOR

create
	make

feature

	make
		do
			create workers.make
		end

	receive_worker (w: separate WORKER)
		do

			workers.put_front (w)
		end

	collect
		do
			print ("Collecting Data from " + workers.count.out + " Workers.%N")
			from
				workers.start
			until
				workers.after
			loop
				receive_results (workers.item)
				workers.forth
			end
		end

	receive_results (w: separate WORKER)
		local
			b: BOOLEAN
		do
			if b then

			else
				b := w.get_result
				print ("This point should NOT be reached!%N")
			end
		rescue
			print ("In Rescue clause of AGGREGATOR.receive_worker. This MUST happen exactly 5 times! Silently swallowing error...%N")
			b := True
			retry
		end

feature {NONE}

	workers: LINKED_LIST[separate WORKER]
end
