--FAIL: Since Safemode is activated, Customers can't "live" in parallel!
--SOLUTION: A fixed, hardcoded number of customers

note
	description	: "System's root class"
	author		: "Robin Stoll"
	date		: "2009/5/16"
	reviewer	: "Mohammad Seyed Alavi"
	revision	: "1.0.1"

class
	BARBERSHOP

create
	make

feature -- Initialization

	make
			-- Setup and execute example.
		local
			c1, c2, c3, c4, c5: separate CUSTOMER
		do
			create shop.make (number_of_chairs)
			create barber.make (time_for_haircut)

			create c1.make (1, barber, shop, number_of_haircuts)
			create c2.make (2, barber, shop, number_of_haircuts)
			create c3.make (3, barber, shop, number_of_haircuts)
			create c4.make (4, barber, shop, number_of_haircuts)
			create c5.make (5, barber, shop, number_of_haircuts)

			launch_customers (c1, c2, c3, c4, c5)
		end

feature {NONE} -- Implementation

	--number_of_customers: INTEGER = 4
			-- Customer count.

	number_of_chairs: INTEGER = 2
			-- Chair count.

	number_of_haircuts: INTEGER = 50
			-- Haircut count per customer.

	time_for_haircut: INTEGER = 100
			-- Duration of haircut.

	barber: separate BARBER
			-- Barber

	shop: separate SHOP
			-- Shop

	launch_customers (c1, c2, c3, c4, c5: separate CUSTOMER)
			-- Start `a_customer's life.
		do
			c1.live
			c2.live
			c3.live
			c4.live
			c5.live
		end

end
