note
	description: "Summary description for {WEBSERVER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WEBSERVER

create
	make

feature

	make
		do
			counter := 0
		end

	serve_request: BOOLEAN
		do
			counter := counter + 1
			if counter = 10 then
				counter := 0
				print("WEBSERVER: Raising 404 Exception%N")
				exception_404.raise
			end
			if counter \\ 2 = 0 then
				print("WEBSERVER: Raising Timeout Exception%N")
				exception_timeout.raise
			end
			print("WEBSERVER: Returning Result%N")
			Result := True
		end

feature {NONE}

	counter: INTEGER

	exception_404: EXCEPTION_404
		once
			create Result
		end

	exception_timeout: EXCEPTION_TIMEOUT
		once
			create Result
		end

end
