note
	description: "Summary description for {HOUSE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	HOUSE

create
	make

feature

	make
		do

		end

	is_finished: BOOLEAN
		do
			Result := has_foundation and has_walls and has_roof
		end

	build_foundation
		do
			has_foundation := True
		end

	build_walls
		require
			has_foundation
		do
			my_exception.raise
		rescue
			has_walls := False
		end

	build_roof
		require
			has_walls
		do
			has_roof := True
		end

feature
	has_foundation: BOOLEAN
	has_walls: BOOLEAN
	has_roof: BOOLEAN

	my_exception: DEVELOPER_EXCEPTION
		once
			create Result
		end

end
