
note
	description : "CallAPI application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w: separate WORKER
			b: BOOLEAN
		do
			if b then

			else
				create w.make
				add_work(w)		--And now RELEASE Lock, so no exception will happen
				query_work(w)	--here!
			end

		rescue
			print ("make has FAILED! This should not happen.%N")
			b := True
			retry
		end

	add_work (w: separate WORKER)
		local
			i: INTEGER
		do
			from
				i := 0
			until
				i = max
			loop
				print ("Adding work " + i.out + " / " + max.out + "%N")
				w.work	--Will fail but catch the exception locally, i.e. without organized panic!
				i := i + 1
			end
		end

	query_work (w: separate WORKER)
		local
			res: INTEGER
		do
			print ("Calls logged: " + max.out + "%N")
			res := w.query
			print ("Calls actually executed: " + res.out + "%N")

			if res = max then
				print ("No calls were thrown away, that is OK!%N")
			else
				print ("Some calls were thrown away, that is BAD!%N")
			end
		end

	max: INTEGER = 1000

end
