
note
	description : "readFile application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		do
			non_create_make
		end

	non_create_make
		local
			w: separate WORKER
			b: BOOLEAN
		do
			if b then
				print ("Bye.%N")
			else
				create w.make
				work (w)
				print ("APPLICATION.work has NOT failed. This should NOT happen!%N")
			end

		rescue
			print ("read has FAILED as it should. Now in rescue clause of make. We swallow the error silently, since this is just a demo ;)%N")
			b := True
			retry
		end


	work (w: separate WORKER)
		local
			b: BOOLEAN
		do
			w.read
--			b := w.query	--Due to Safemode no query needed!
		rescue
			print ("Now in rescue clause of APPLICATION.work. This MUST happen!%N")
		end

end
