note
	description : "sandbox application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

create
	make

feature {NONE} -- Initialization

	make
			-- Places async call
			-- No exceptions locally
			-- No exceptiosn propagated
			-- Gets/releases lock with each call
		local
			i: INTEGER
			w: separate WORKER
		do
			from
			until
				i > repeat
			loop
				if i \\ step = 0 then
					print (i.out + "/" + repeat.out + "%N")
				end
				create w.make
				do_work_exception (w)
			end
		rescue
			i := i + 1
			retry
		end


	do_work_exception (w: separate WORKER)
		local
			b: BOOLEAN
		do
			b := w.fail
		end

	repeat: INTEGER = 100000
	step: INTEGER = 10000
	repeat_small: INTEGER = 1000
	step_small: INTEGER = 100
end
