note
	description: "Summary description for {WORKER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WORKER

create
	make

feature

	make (i: INTEGER; d: separate DEDICATED_FILE_READER; a: separate ANSWER_REGISTER)
		do
			dfr := d
			ans := a
			number := i
		end

	live
		do
			from

			until
				counter > 100
			loop
				if not waiting then
					queue_file (dfr)
				end
				nudge (dfr)
				get_results (ans)
			end
		rescue
			--print ("WORKER: In rescue of live%N")
			retry	--Ah, the good old on error continue ;)
		end

	queue_file (d: separate DEDICATED_FILE_READER)
		do
			d.queue_file (counter.out)
		rescue
			--print ("WORKER: In rescue of queue_file%N")
		end

	get_results (a: separate ANSWER_REGISTER)
		local
			res: STRING
		do
			create res.make_from_separate ( a.get_results (counter.out) )
			if res.count > 0 then
				waiting := False
				counter := counter + 1
				--print ("WORKER: Result: " + res + "%N")
			else
				waiting := True
				--print ("WORKER " + number.out + ": Result: None, waiting.%N")
			end
		rescue
			print ("WORKER " + number.out + ": Encountered exception getting result. Seems like file was not readable ;(%N")
			waiting := False
			counter := counter + 1
		end

	nudge (d: separate DEDICATED_FILE_READER)
		do
			d.read_file
		rescue
			--print ("WORKER: In rescue of nudge%N")
		end

feature {NONE}

	dfr: separate DEDICATED_FILE_READER
	ans: separate ANSWER_REGISTER
	waiting: BOOLEAN
	counter: INTEGER
	number: INTEGER

end
