--FAIL: Safemode has problems with long-lived entities, so the must all be created at once.
--SOLUTION: Hack
--Rest should work


note
	description : "readfile_improved_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			w1, w2: separate WORKER
			bb: separate BOUNDED_BUFFER[INTEGER]
			dfr: separate DEDICATED_FILE_READER
			ans: separate ANSWER_REGISTER
		do
			create ans.make
			create bb.make_with_capacity(10)
			create dfr.make (ans, bb)

			create w1.make (1, bb, ans)
			create w2.make (2, bb, ans)

			start_all (dfr, w1, w2)

		end

	start_all (dfr: separate DEDICATED_FILE_READER; w1, w2: separate WORKER)
		do
			dfr.live
			w1.live
			w2.live
		end

end
