--FAIL: The usual when dealing with long-lived entities.
--SOLUTION: Hack
--BONUS: The Hack nicely solves the problem of lock passing / lock releasing that plagued the normal version.


note
	description : "Internet_grabber_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			a: separate AGGREGATOR
			w1, w2, w3, w4, w5: separate WORKER
		do
			create a.make
			create w1.make
			create w2.make
			create w3.make
			create w4.make
			create w5.make

			make_work_and_pass (a, w1, w2, w3, w4, w5)
		end

	make_work_and_pass (a: separate AGGREGATOR; w1, w2, w3, w4, w5: separate WORKER)
		do
			w1.work
			w2.work
			w3.work
			w4.work
			w5.work
			a.receive_workers (w1, w2, w3, w4, w5)
		end
end
