note
	description : "exceptions_and_once_routines application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	failer: attached separate FAILER

	make
			-- Run application.
		local
			stop: BOOLEAN
		do
			if not stop then
				create failer.make
				execute_without_sync (failer)
				execute_with_sync (failer)

				print ("At end of APPLICATION.make. This should never happen.%N")
			end
		rescue
			print ("In Rescue of APPLICATION.make. This is OK%N")
			stop := True
			retry
		end

	execute_without_sync (a_failer: attached separate FAILER)
		do
			a_failer.fail
		end

	execute_with_sync (a_failer: attached separate FAILER)
		local
			i: attached INTEGER
		do
			a_failer.fail
			i := a_failer.counter
		end
end
