note
	description: "Summary description for {CONTROLLER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CONTROLLER

create
	make

feature

	first_searcher, second_searcher: attached separate SEARCHER
	log: attached separate LOG

	make
		local
			stop: BOOLEAN
		do
			if not stop then
				create first_searcher.make
				create second_searcher.make
				create log.make
				start (first_searcher, second_searcher, log)
--				dummY (second_searcher)	--Will throws exception if in never_forget and the exception has not already propagated.

				print("Reached end of CONTROLLER.make. This should ONLY happen if SAFEMODE=OFF and the first searcher succeeds. Currently, the first searcher succeeds.%N")
			end
		rescue
			print("Reached Rescue of CONTROLLER.make. This should happen if SAFEMODE=ON or the first searcher fails. Currently, the first searcher succeeds.%N")
			stop := True
			retry
		end

	start (a_first_searcher, a_second_searcher: attached separate SEARCHER; a_log: attached separate LOG)
		do
			a_first_searcher.search(10)
			a_second_searcher.search(-1)
			a_log.add_entry(a_first_searcher, a_second_searcher)
		rescue
			print ("In rescue of start%N")
		end

	dummY (a_searcher: attached separate SEARCHER)
		local
			s: separate SOLUTION
		do
			s := a_searcher.solution
		rescue
			print ("In rescue of dummy%N")
		end
end
