--FAIL: This does not work as long as the only returned exception is a "SCOOP Failed Exception". We need multiple return types!


note
	description : "WebFileTransfer application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			i: INTEGER
		do
			if i = 0 then

				create webs.make

				from
					i := 1
				until
					i > 6
				loop
					i := i+1
					work (webs)
				end
			end
		rescue
			print ("APPLICATION: Now in Rescue of make, this should happen. Swallowing error.%N")
			retry
		end

	work (webserver: separate WEBSERVER)
		local
			response: BOOLEAN
			l_exception_404: EXCEPTION_404
			l_exception_timeout: EXCEPTION_TIMEOUT
		do
			response := webserver.serve_request
			print ("APPLICATION: Gotten response.%N")
		rescue
			print("APPLICATION: In rescue clause of APPLICATION.work.%N")
			l_exception_404 ?= (create {ISE_EXCEPTION_MANAGER}).last_exception
			l_exception_timeout ?= (create {ISE_EXCEPTION_MANAGER}).last_exception
			if l_exception_timeout /= Void then
				print ("APPLICATION: Timeout received, simply trying again...%N")
				retry
			elseif l_exception_404 /= Void then
				print ("APPLICATION: 404 received, not handling that error.%N")
			else
				print ("APPLICATION: Unknown error received, not handling it.%N")
			end
		end


	webs: separate WEBSERVER

end
