note
	description : "build_a_house_scoop application root class"
	date        : "$Date$"
	revision    : "$Revision$"

class
	APPLICATION

inherit
	ARGUMENTS

create
	make

feature {NONE} -- Initialization

	make
		local
			h: separate HOUSE
			b: BOOLEAN
		do
			create h.make

			b := build_whole (h)

			if b then
				print ("House built! NOT OK.%N")
			else
				print ("Failed to build! This is OK.%N")
			end
		end

	build_whole (h: separate HOUSE): BOOLEAN
		local
			b: BOOLEAN
		do
			if b then

			else
				h.build_foundation
				h.build_walls							--Asynchronous calls on a failed supplier can yield exception in old system!
				h.build_roof

				Result := h.is_finished					--Not needed for Safemode
			end
		rescue
			Result := False
			b := True
			retry
		end

end
